// =============================================================================
// AntiCheatEngine BETA 0.8 - (c) 2009-2010 AnthraX
//
// SH: ToDo?
// - Caps shouldn't be necessary if server administrators are careful to store
//   hashes in UPPERCASE in the ini file
// - Use a delimited format for stored values? Something like hash|packageName
//   To make it easier to remember what each hash represents?
// - One loop for all arrays? But they might have different sizes depending on
//   requirements
//
// Ini file values stored in \System\ACEWhitelist.ini
// [ACEv08h_EH.ACEWhiteList]
// =============================================================================
class ACEWhitelist extends Actor config(ACEWhitelist);

var config string gaPackages[32];
var config string gaHardwareIDs[32];
var config string gaLibraries[32];

//-----------------------------------------------------------------------------
// For .u files
//-----------------------------------------------------------------------------
function bool isWhitelistedPackage(string packageHash)
{
  local int i;
  local string uppHash;

  uppHash = Caps(packageHash);

  for (i = 0; i < arrayCount(gaPackages); i++)
  {
    if (gaPackages[i] == "")
      break;

    if (Caps(gaPackages[i]) == uppHash)
      return true;
  }

  return false;
}

//-----------------------------------------------------------------------------
function bool isWhitelistedPlayer(string hardwareID)
{
  local int i;
  local string uppHash;

  uppHash = Caps(hardwareID);

  for (i = 0; i < arrayCount(gaHardwareIDs); i++)
  {
    if (gaHardwareIDs[i] == "")
      break;

    if (Caps(gaHardwareIDs[i]) == uppHash)
      return true;
  }

  return false;
}

//-----------------------------------------------------------------------------
// For .dll files
//-----------------------------------------------------------------------------
function bool isWhitelistedLibrary(string libraryHash)
{
  local int i;
  local string uppHash;

  uppHash = Caps(libraryHash);

  for (i = 0; i < arrayCount(gaLibraries); i++)
  {
    if (gaLibraries[i] == "")
      break;

    if (Caps(gaLibraries[i]) == uppHash)
      return true;
  }

  return false;
}