// =============================================================================
// AntiCheatEngine BETA 0.8 - (c) 2009 AnthraX
// =============================================================================
// IACEActor: base class of the main serveractor
// =============================================================================
class IACEActor extends IACECommon
    config(System);

// =============================================================================
// Config Variables
// =============================================================================
var config float  InitialCheckLinger;     // How many seconds do we wait before running the initial check?
var config float  InitialCheckTimeout;    // How many seconds are allowed to run the initial check?
var config float  PeriodicCheckInterval;  // How many seconds in between checks?
var config float  PeriodicCheckTimeout;   // How many seconds are allowed to run the periodic check?
var config float  SShotTimeOut;           // How many seconds do we allow for a screenshot?
var config bool   bSShotWhenKick;         // Make a screenshot before kicking?
var config string SShotPath;              // Path to store sshots
var config string SShotPrefix;            // Prefix for sshot files
var config int    SShotQuality;           // Quality of the screenshots
var config bool   bAutoConfig;            // Automatically configure ACE?
var config string AutoConfigPackage;      // Package that contains the autoconfigactor
var config bool   bAutoUpdate;            // Automatically download new file definitions from the interwebz?
var config string UPackages[32];          // UScript packages to validate (BaseName!)
var config string NativePackages[32];     // Libraries to validate
var config bool   bExternalLog;           // Is external logging allowed
var config string LogPath;                // Path to log to
var config string LogPrefix;              // Prefix for external logfiles
var config bool   bExternalLogJoins;      // Log playerjoins to an external file?
var config string JoinLogPath;            // Path to log playerjoins to
var config string JoinLogPrefix;          // Prefix for playerjoin logs
var config string AdminPass;              // Password for silent admin commands
var config bool   bAllowCrosshairScaling; // Allow the player to change their crosshair scale?
var config bool   bShowLogo;              // Show the ACE logo and the loading status?
var config float  LogoXPos;               // X coordinate of the top left corner of the logo
var config float  LogoYPos;               // Y coordinate of the top left corner of the logo
var config bool   bAllowUnknownPackages;  // Allow certain unknown packages (UnrealShare, UnrealI)

// =============================================================================
// PostBeginPlay ~ Log startup banner
// =============================================================================
function PostBeginPlay()
{
    ACEPadLog("","-","+",40,true);
    ACEPadLog("ACE for Unreal Tournament"," ","|",40,true);
    ACEPadLog("BETA "$ACEVersion," ","|",40,true);
    ACEPadLog("(c) 2009-2010 - AnthraX"," ","|",40,true);
    ACEPadLog("","-","+",40,true);
    MyPostBeginPlay();
}

// =============================================================================
// Public Function Prototypes
// =============================================================================
function MyPostBeginPlay();
function bool RegisterEventHandler(IACEEventHandler EventHandler);
function bool UnregisterEventHandler(IACEEventHandler EventHandler);
function NotifyEventHandlers(name EventType, IACECheck Check, string EventData);
function string GetDefinitionFileVersion();
function bool IdentifyFile(string FileName, string FileHash, int FileSize, out string FileVersion);
function NotifyDestroyed(Object Obj);
function float GetTimeoutMultiplier(IACECheck Check, int CheckNum, int OSVer, int CPUCores);

// =============================================================================
// defaultproperties
// =============================================================================

defaultproperties
{
     InitialCheckLinger=5.000000
     InitialCheckTimeout=70.000000
     PeriodicCheckInterval=45.000000
     PeriodicCheckTimeout=60.000000
     SShotTimeOut=40.000000
     bSShotWhenKick=True
     SShotPath="../Shots/"
     SShotPrefix="[ACE]"
     SShotQuality=85
     bAutoConfig=True
     AutoConfigPackage="ACEv08_AutoConfig"
     bAutoUpdate=True
     bExternalLog=True
     LogPath="../Logs/"
     LogPrefix="[ACE]"
     bExternalLogJoins=True
     JoinLogPath="../Logs/"
     JoinLogPrefix="[ACEPLAYERS]"
     bAllowCrosshairScaling=True
     bShowLogo=True
     LogoXPos=10.000000
     LogoYPos=-100.000000
     bAlwaysTick=True
}
